float barWidth = 40; //width of gradient bars
float barStartHeight = 10; 
float arrowScale = 6; //scales elevation arrow height, higher number = smaller arrow
PImage gradientSign;
PImage map;
PFont font;
PShape arrow;

Climb AlpeDHuez;     //create instances of class Climb
Climb MontVentoux;
Climb ColDuTourmalet;
Climb ColDAbisque;
Climb PassoStelvio;
//Climb Zoncolan;


void setup() {    //load images and populate instances of class Climb
  size(800, 800);
  background(150);
  noStroke();
  smooth();
  fill(255);
  gradientSign = loadImage("gradient sign.png");
  map = loadImage("france_map.jpg");
  font = loadFont("Helvetica-30.vlw");

  AlpeDHuez = new Climb("Alpe D'Huez", 14, new float[]{5, 10.5, 10, 8.5, 9, 8, 7.5, 9.5, 8, 6.5, 11.5, 9, 4.5, 5.5}, 14, 8.1, 1143);
  MontVentoux = new Climb("Mont Ventoux", 21, new float[]{2, 3.5, 4.5, 6, 6, 4.5, 9.5, 9.5, 11, 9, 10, 9.5, 8.5, 10.5, 8, 7.5, 6, 7, 7.5, 8, 10}, 12, 7.6, 1622);
  ColDuTourmalet = new Climb("Col Du Tourmalet", 19, new float[]{3.5, 5.5, 6.5, 8, 7.5, 7, 7, 7.5, 8.5, 8.5, 5.5, 8, 7.5, 8, 7.5, 9.5, 8, 7.5, 10}, 13, 7.4, 1404);
  ColDAbisque = new Climb("Col D'Abisque", 18, new float[]{4.5, 4.5, 5, 5, 2.5, 4.5, 5, 7, 8.5, 8.5, 6.5, 7.5, 8.5, 7.5, 8.5, 8.5, 8, 9}, 14, 7.2, 1190);
  PassoStelvio = new Climb("Passo Stelvio", 25, new float[]{2, 5, 5, 5, 6, 6, 7, 5, 8, 8, 6.5, 7.5, 8.5, 7.5, 8, 9, 8.5, 9, 9, 8, 8.5, 8.5, 7.5, 8.5, 9.5}, 14, 7.1, 1842);
  //Zoncolan = new Climb(10, new float[]{9.5, 8.5, 16, 16.5, 15, 15.5, 18, 14, 9, 9.5}, 23, 11.9, 1225);
}

void draw() {
}

void mouseMoved() {   //handle mouseover interactions
  if ((mouseX>659 && mouseX<671) && (mouseY>535 && mouseY<547)) {
    background(150);
    AlpeDHuez.display();
  } else if ((mouseX>624 && mouseX<636) && (mouseY>609 && mouseY<621)) {
    background(150);
    MontVentoux.display();
  } else if ((mouseX>274 && mouseX<286) && (mouseY>738 && mouseY<750)) {
    background(150);
    ColDuTourmalet.display();
  } else if ((mouseX>294 && mouseX<306) && (mouseY>744 && mouseY<756)) {
    background(150);
    ColDAbisque.display();
  } else if ((mouseX>771 && mouseX<783) && (mouseY>441 && mouseY<453)) {
    background(150);
    PassoStelvio.display();
  } else {
    image(map, 0, 0, 800, 800);
    fill(70);
    ellipse(665, 541, 12, 12); //Alpe D'Huez
    ellipse(630, 615, 12, 12); //Mont Ventoux
    ellipse(280, 744, 12, 12); //Col du Tourmalet
    ellipse(300, 750, 12, 12); //Col D'Abisque
    ellipse(777, 447, 12, 12); //Passo Stelvio
  }
}

void gradientSign(float x, float y, float maxGradient) {   //draw gradient signs
  image(gradientSign, x, y, 200, 533/3);  //550,300,200, 533/3
  fill(255);
  triangle(x+19, y+158, x+100, y+20, x+140, y+90);  //(569, 458, 650, 320, 690 , 390);  
  fill(0);
  textSize(30);
  pushMatrix();     //rotate text and position
  translate(x+60, y+130);
  rotate(PI/-5.4);
  String gradString = nf(maxGradient, 0, 1);
  text(gradString+"%", 0, 0);
  popMatrix();
}

void elevationArrow(float x, float y, float elevation) { //draw arrow shape
  arrow = createShape();
  arrow.beginShape();
  arrow.fill(70);
  arrow.stroke(0);
  smooth();
  arrow.vertex(x, y);
  arrow.vertex(x, y-elevation/arrowScale+60);
  arrow.vertex(x-20, y-elevation/arrowScale+60);
  arrow.vertex(x+20, y-elevation/arrowScale);
  arrow.vertex(x+60, y-elevation/arrowScale+60);
  arrow.vertex(x+40, y-elevation/arrowScale+60);
  arrow.vertex(x+40, y);
  arrow.vertex(x, y);
  arrow.endShape();
  shape(arrow, 0, 0);
  textSize(26);
  fill(0, 255, 0);
  String elev = str(int(nf(elevation, 0, 0)));   //create text in arrow
  for (int i=1; i<=elev.length(); i++) {
    text(elev.substring(i-1, i), x+12, (y-elevation/arrowScale+60)+i*24);
  }
  fill(0);
  textSize(14);
  text("Elevation (meters)", x-35, y+22);
}


//Class definition for Climb
class Climb {
  String name;
  float numKs;
  float[] gradients;
  float maxGradient;
  float avgGradient;
  float ascent;

  Climb(String tempname, float tempNumKs, float[] tempgradients, float tempmaxGradient, float tempavgGradient, float tempascent) {

    name = tempname;
    numKs = tempNumKs;
    gradients = tempgradients;
    maxGradient = tempmaxGradient;
    avgGradient = tempavgGradient;
    ascent = tempascent;
  }

  void display() {   //display function called during mouseOver function
    noStroke();     //handles drawing and coloring bars and positioning of signs
    float x = 20;
    float y = 400;
    textSize(10);
    float barWidth = (width*.65)/gradients.length;
    float topLeft = y-barStartHeight;
    for (float i : gradients) {   //loop through gradients
      if (i <= 5) {                //set fill color based on gradient
        fill(#47C93F);
      } else if (i > 5 && i <= 7.5) {
        fill(#F7F014);
      } else if (i > 7.5 && i <= 9.5) {
        fill(#FA9F17);
      } else {
        fill(#F72714);
      }
      quad(x, topLeft, x+barWidth-2, topLeft-(i/barWidth)*40, x+barWidth-2, y, x, y);    //draw quads with sloped tops
      String grad = nf(i, 0, 1);
      fill(255);
      text(grad+"%", x+6, topLeft-(i/barWidth)*40-10);   //label each bar with gradient amount
      x += barWidth;
      topLeft = topLeft-(i/barWidth)*40;   //ensure that next bar starts at same height as previous bar
    }
    fill(0);
    rect(20,415,2,12);
    rect(20,420,gradients.length*barWidth,2); //draw line for number of kms
    rect(gradients.length*barWidth+18,415,2,12);
    textSize(14);
    text(nf(numKs,0,1), gradients.length*barWidth+30, 426);
    text("kms", gradients.length*barWidth+60, 426);
    println(gradients.length*barWidth);
    
    gradientSign(50, 550, maxGradient);   //draw signs for max gradient, avg gradient
    textSize(14);
    text("Max Gradient", 100, 750);
    gradientSign(300, 550, avgGradient);
    textSize(14);
    text("Average Gradient", 340, 750);
    
    strokeWeight(2);
    elevationArrow(600, 730, ascent);    //draw arrow
    textSize(30);
    fill(255);
    textFont(font);
    text(name, 100, 100);
  }
}